ViewVC Help
View File | Revision Log | Show Annotations | Download File | Root Listing
root/radiance/ray/src/util/genBSDF.pl
(Generate patch)

Comparing ray/src/util/genBSDF.pl (file contents):
Revision 2.22 by greg, Fri Jun 24 00:41:51 2011 UTC vs.
Revision 2.42 by greg, Tue Apr 23 23:22:09 2013 UTC

# Line 8 | Line 8
8   use strict;
9   use File::Temp qw/ :mktemp  /;
10   sub userror {
11 <        print STDERR "Usage: genBSDF [-n Nproc][-c Nsamp][-t{3|4} Nlog2][-r \"ropts\"][-dim xmin xmax ymin ymax zmin zmax][{+|-}f][{+|-}b][{+|-}mgf][{+|-}geom] [input ..]\n";
11 >        print STDERR "Usage: genBSDF [-n Nproc][-c Nsamp][-t{3|4} Nlog2][-r \"ropts\"][-dim xmin xmax ymin ymax zmin zmax][{+|-}f][{+|-}b][{+|-}mgf][{+|-}geom units] [input ..]\n";
12          exit 1;
13   }
14   my $td = mkdtemp("/tmp/genBSDF.XXXXXX");
# Line 16 | Line 16 | chomp $td;
16   my @savedARGV = @ARGV;
17   my $tensortree = 0;
18   my $ttlog2 = 4;
19 < my $nsamp = 1000;
19 > my $nsamp = 2000;
20   my $rtargs = "-w -ab 5 -ad 700 -lw 3e-6";
21   my $mgfin = 0;
22   my $geout = 1;
23   my $nproc = 1;
24   my $doforw = 0;
25   my $doback = 1;
26 < my $gunit = "Meter";
26 > my $pctcull = 90;
27 > my $gunit = "meter";
28   my @dim;
29   # Get options
30   while ($#ARGV >= 0) {
# Line 43 | Line 44 | while ($#ARGV >= 0) {
44                  $doforw = ("$ARGV[0]" =~ /^\+/);
45          } elsif ("$ARGV[0]" =~ /^[-+]b/) {
46                  $doback = ("$ARGV[0]" =~ /^\+/);
47 +        } elsif ("$ARGV[0]" eq "-t") {
48 +                # Use value < 0 for rttree_reduce bypass
49 +                $pctcull = $ARGV[1];
50 +                shift @ARGV;
51          } elsif ("$ARGV[0]" =~ /^-t[34]$/) {
52                  $tensortree = substr($ARGV[0], 2, 1);
53                  $ttlog2 = $ARGV[1];
# Line 66 | Line 71 | while ($#ARGV >= 0) {
71   }
72   # Check that we're actually being asked to do something
73   die "Must have at least one of +forward or +backward\n" if (!$doforw && !$doback);
69 # Name our own persist file?
70 my $persistfile;
71 if ( $tensortree && $nproc > 1 && "$rtargs" !~ /-PP /) {
72        $persistfile = "$td/pfile.txt";
73        $rtargs = "-PP $persistfile $rtargs";
74 }
74   # Get scene description and dimensions
75   my $radscn = "$td/device.rad";
76   my $mgfscn = "$td/device.mgf";
# Line 109 | Line 108 | print
108   print "<!-- File produced by: genBSDF @savedARGV -->\n";
109   print
110   '<WindowElementType>System</WindowElementType>
111 + <FileType>BSDF</FileType>
112   <Optical>
113   <Layer>
114          <Material>
# Line 118 | Line 118 | print
118   printf "\t\t<Thickness unit=\"$gunit\">%.3f</Thickness>\n", $dim[5] - $dim[4];
119   printf "\t\t<Width unit=\"$gunit\">%.3f</Width>\n", $dim[1] - $dim[0];
120   printf "\t\t<Height unit=\"$gunit\">%.3f</Height>\n", $dim[3] - $dim[2];
121 < print "\t\t<DeviceType>Integral</DeviceType>\n";
121 > print "\t\t<DeviceType>Other</DeviceType>\n";
122 > print " </Material>\n";
123   # Output MGF description if requested
124   if ( $geout ) {
125 <        print "\t\t<Geometry format=\"MGF\" unit=\"$gunit\">\n";
125 >        print "\t<Geometry format=\"MGF\">\n";
126 >        print "\t\t<MGFblock unit=\"$gunit\">\n";
127          printf "xf -t %.6f %.6f 0\n", -($dim[0]+$dim[1])/2, -($dim[2]+$dim[3])/2;
128          open(MGFSCN, "< $mgfscn");
129          while (<MGFSCN>) { print $_; }
130          close MGFSCN;
131          print "xf\n";
132 <        print "\t\t</Geometry>\n";
132 >        print "</MGFblock>\n";
133 >        print "\t</Geometry>\n";
134   }
132 print " </Material>\n";
135   # Set up surface sampling
136   my $nx = int(sqrt($nsamp*($dim[1]-$dim[0])/($dim[3]-$dim[2])) + .5);
137   my $ny = int($nsamp/$nx + .5);
# Line 149 | Line 151 | print
151   </WindowElement>
152   ';
153   # Clean up temporary files and exit
152 if ( $persistfile && open(PFI, "< $persistfile") ) {
153        while (<PFI>) {
154                s/^[^ ]* //;
155                kill('ALRM', $_);
156                last;
157        }
158        close PFI;
159 }
154   exec("rm -rf $td");
155  
156   #-------------- End of main program segment --------------#
157  
158   #++++++++++++++ Tensor tree BSDF generation ++++++++++++++#
159   sub do_tree_bsdf {
166 # Get sampling rate and subdivide task
167 my $ns2 = $ns;
168 $ns2 /= 2 if ( $tensortree == 3 );
169 @pdiv = (0, int($ns2/$nproc));
170 my $nrem = $ns2 % $nproc;
171 for (my $i = 1; $i < $nproc; $i++) {
172        my $nv = $pdiv[$i] + $pdiv[1];
173        ++$nv if ( $nrem-- > 0 );
174        push @pdiv, $nv;
175 }
176 die "Script error 1" if ($pdiv[-1] != $ns2);
160   # Shirley-Chiu mapping from unit square to disk
161   $sq2disk = '
162   in_square_a = 2*in_square_x - 1;
# Line 216 | Line 199 | out_square_y = (out_square_b + 1)/2;
199   print "\t<DataDefinition>\n";
200   print "\t\t<IncidentDataStructure>TensorTree$tensortree</IncidentDataStructure>\n";
201   print "\t</DataDefinition>\n";
202 < # Fork parallel rtcontrib processes to compute each side
203 < if ( $doback ) {
204 <        for (my $proc = 0; $proc < $nproc; $proc++) {
205 <                bg_tree_rtcontrib(0, $proc);
206 <        }
224 <        while (wait() >= 0) {
225 <                die "rtcontrib process reported error" if ( $? );
226 <        }
227 <        ttree_out(0);
228 < }
229 < if ( $doforw ) {
230 <        for (my $proc = 0; $proc < $nproc; $proc++) {
231 <                bg_tree_rtcontrib(1, $proc);
232 <        }
233 <        while (wait() >= 0) {
234 <                die "rtcontrib process reported error" if ( $? );
235 <        }
236 <        ttree_out(1);
237 < }
202 >
203 > # Start rcontrib processes for compute each side
204 > do_tree_rtcontrib(0) if ( $doback );
205 > do_tree_rtcontrib(1) if ( $doforw );
206 >
207   }       # end of sub do_tree_bsdf()
208  
209 < # Run i'th rtcontrib process for generating tensor tree samples
210 < sub bg_tree_rtcontrib {
242 <        my $pid = fork();
243 <        die "Cannot fork new process" unless defined $pid;
244 <        if ($pid > 0) { return $pid; }
209 > # Run rcontrib process to generate tensor tree samples
210 > sub do_tree_rtcontrib {
211          my $forw = shift;
246        my $pn = shift;
247        my $pbeg = $pdiv[$pn];
248        my $plen = $pdiv[$pn+1] - $pbeg;
212          my $matargs = "-m $bmodnm";
213 <        if ( !$forw || !$doback ) { $matargs .= " -m $fmodnm"; }
214 <        my $cmd = "rtcontrib $rtargs -h -ff -fo -c $nsamp " .
213 >        if ( !$forw || !$doback || $tensortree==3 ) { $matargs .= " -m $fmodnm"; }
214 >        my $cmd = "rcontrib $rtargs -h -ff -fo -n $nproc -c $nsamp " .
215                  "-e '$disk2sq' -bn '$ns*$ns' " .
216                  "-b '$ns*floor(out_square_x*$ns)+floor(out_square_y*$ns)' " .
217 <                "-o $td/%s_" . sprintf("%03d", $pn) . ".flt $matargs $octree";
217 >                "-o $td/%s.flt $matargs $octree";
218          if ( $tensortree == 3 ) {
219                  # Isotropic BSDF
220 <                $cmd = "cnt $plen $ny $nx " .
221 <                        "| rcalc -e 'r1=rand(($pn+.8681)*recno-.673892)' " .
222 <                        "-e 'r2=rand(($pn-5.37138)*recno+67.1737811)' " .
223 <                        "-e 'r3=rand(($pn+3.17603772)*recno+83.766771)' " .
224 <                        "-e 'Dx=1-2*($pbeg+\$1+r1)/$ns;Dy:0;Dz=sqrt(1-Dx*Dx)' " .
220 >                my $ns2 = $ns / 2;
221 >                $cmd = "cnt $ns2 $ny $nx " .
222 >                        "| rcalc -e 'r1=rand(.8681*recno-.673892)' " .
223 >                        "-e 'r2=rand(-5.37138*recno+67.1737811)' " .
224 >                        "-e 'r3=rand(+3.17603772*recno+83.766771)' " .
225 >                        "-e 'Dx=1-2*(\$1+r1)/$ns;Dy:0;Dz=sqrt(1-Dx*Dx)' " .
226                          "-e 'xp=(\$3+r2)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
227                          "-e 'yp=(\$2+r3)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
228                          "-e 'zp=$dim[5-$forw]' -e 'myDz=Dz*($forw*2-1)' " .
# Line 269 | Line 233 | sub bg_tree_rtcontrib {
233                  # Anisotropic BSDF
234                  # Sample area vertically to improve load balance, since
235                  # shading systems usually have bilateral symmetry (L-R)
236 <                $cmd = "cnt $plen $ns $ny $nx " .
237 <                        "| rcalc -e 'r1=rand(($pn+.8681)*recno-.673892)' " .
238 <                        "-e 'r2=rand(($pn-5.37138)*recno+67.1737811)' " .
239 <                        "-e 'r3=rand(($pn+3.17603772)*recno+83.766771)' " .
240 <                        "-e 'r4=rand(($pn-2.3857833)*recno-964.72738)' " .
241 <                        "-e 'in_square_x=($pbeg+\$1+r1)/$ns' " .
236 >                $cmd = "cnt $ns $ns $ny $nx " .
237 >                        "| rcalc -e 'r1=rand(.8681*recno-.673892)' " .
238 >                        "-e 'r2=rand(-5.37138*recno+67.1737811)' " .
239 >                        "-e 'r3=rand(3.17603772*recno+83.766771)' " .
240 >                        "-e 'r4=rand(-2.3857833*recno-964.72738)' " .
241 >                        "-e 'in_square_x=(\$1+r1)/$ns' " .
242                          "-e 'in_square_y=(\$2+r2)/$ns' -e '$sq2disk' " .
243                          "-e 'xp=(\$4+r3)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
244                          "-e 'yp=(\$3+r4)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
# Line 284 | Line 248 | sub bg_tree_rtcontrib {
248                          "| $cmd";
249          }
250   # print STDERR "Starting: $cmd\n";
251 <        exec($cmd);             # no return; status report to parent via wait
252 <        die "Cannot exec: $cmd\n";
253 < }       # end of bg_tree_rtcontrib()
251 >        system "$cmd" || die "Failure running rcontrib";
252 >        ttree_out($forw);
253 > }       # end of do_tree_rtcontrib()
254  
255   # Simplify and output tensor tree results
256   sub ttree_out {
257          my $forw = shift;
258          my $side = ("Back","Front")[$forw];
259 < # Only output one transmitted distribution, preferring backwards
260 < if ( !$forw || !$doback ) {
259 >        my $cmd;
260 > # Only output one transmitted anisotropic distribution, preferring backwards
261 > if ( !$forw || !$doback || $tensortree==3 ) {
262   print
263   '       <WavelengthData>
264                  <LayerNumber>System</LayerNumber>
# Line 301 | Line 266 | print
266                  <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
267                  <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
268                  <WavelengthDataBlock>
269 <                        <WavelengthDataDirection>Transmission</WavelengthDataDirection>
270 <                        <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
269 > ';
270 > print "\t\t\t<WavelengthDataDirection>Transmission $side</WavelengthDataDirection>\n";
271 > print
272 > '                       <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
273                          <ScatteringDataType>BTDF</ScatteringDataType>
274                          <ScatteringData>
275   ';
276 < system "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
277 <        q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' -of } .
278 <        "$td/" . ($bmodnm,$fmodnm)[$forw] . "_???.flt " .
279 <        "| rttree_reduce -h -ff -r $tensortree -g $ttlog2";
280 < die "Failure running rttree_reduce" if ( $? );
276 > $cmd = "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
277 >        q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' };
278 > if ($pctcull >= 0) {
279 >        $cmd .= "-of $td/" . ($bmodnm,$fmodnm)[$forw] . ".flt " .
280 >        "| rttree_reduce -a -h -ff -t $pctcull -r $tensortree -g $ttlog2";
281 >        system "$cmd" || die "Failure running rttree_reduce";
282 > } else {
283 >        $cmd .= "$td/" . ($bmodnm,$fmodnm)[$forw] . ".flt";
284 >        print "{\n";
285 >        system "$cmd" || die "Failure running rcalc";
286 >        for (my $i = ($tensortree==3)*$ns*$ns*$ns/2; $i-- > 0; ) {
287 >                print "0\n";
288 >        }
289 >        print "}\n";
290 > }
291   print
292   '                       </ScatteringData>
293                  </WavelengthDataBlock>
# Line 329 | Line 306 | print
306   print "\t\t\t<WavelengthDataDirection>Reflection $side</WavelengthDataDirection>\n";
307   print
308   '                       <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
309 <                        <ScatteringDataType>BRDF</ScatteringDataType>
309 >                        <ScatteringDataType>BTDF</ScatteringDataType>
310                          <ScatteringData>
311   ';
312 < system "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
313 <        q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' -of } .
314 <        "$td/" . ($fmodnm,$bmodnm)[$forw] . "_???.flt " .
315 <        "| rttree_reduce -h -ff -r $tensortree -g $ttlog2";
316 < die "Failure running rttree_reduce" if ( $? );
312 > $cmd = "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
313 >        q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' };
314 > if ($pctcull >= 0) {
315 >        $cmd .= "-of $td/" . ($fmodnm,$bmodnm)[$forw] . ".flt " .
316 >        "| rttree_reduce -a -h -ff -t $pctcull -r $tensortree -g $ttlog2";
317 >        system "$cmd" || die "Failure running rttree_reduce";
318 > } else {
319 >        $cmd .= "$td/" . ($fmodnm,$bmodnm)[$forw] . ".flt";
320 >        print "{\n";
321 >        system "$cmd" || die "Failure running rcalc";
322 >        for (my $i = ($tensortree==3)*$ns*$ns*$ns/2; $i-- > 0; ) {
323 >                print "0\n";
324 >        }
325 >        print "}\n";
326 > }
327   print
328   '                       </ScatteringData>
329                  </WavelengthDataBlock>
# Line 353 | Line 340 | sub do_matrix_bsdf {
340   $tcal = '
341   DEGREE : PI/180;
342   sq(x) : x*x;
343 < Kpola(r) : select(r+1, -5, 5, 15, 25, 35, 45, 55, 65, 75, 90);
343 > Kpola(r) : select(r+1, 0, 5, 15, 25, 35, 45, 55, 65, 75, 90);
344   Knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12);
345   Kaccum(r) : if(r-.5, Knaz(r) + Kaccum(r-1), 0);
346   Kmax : Kaccum(Knaz(0));
# Line 374 | Line 361 | KprojOmega = PI * if(Kbin-.5,
361   $kcal = '
362   DEGREE : PI/180;
363   abs(x) : if(x, x, -x);
364 < Acos(x) : 1/DEGREE * if(x-1, 0, if(-1-x, 0, acos(x)));
364 > Acos(x) : if(x-1, 0, if(-1-x, PI, acos(x))) / DEGREE;
365   posangle(a) : if(-a, a + 2*PI, a);
366 < Atan2(y,x) : 1/DEGREE * posangle(atan2(y,x));
366 > Atan2(y,x) : posangle(atan2(y,x)) / DEGREE;
367   kpola(r) : select(r, 5, 15, 25, 35, 45, 55, 65, 75, 90);
368   knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12);
369   kaccum(r) : if(r-.5, knaz(r) + kaccum(r-1), 0);
# Line 397 | Line 384 | kbin2(pol,azi) = select(kfindrow(1, pol),
384   kbin = kbin2(Acos(abs(Dz)),Atan2(Dy,Dx));
385   ';
386   my $ndiv = 145;
387 < # Compute scattering data using rtcontrib
387 > # Compute scattering data using rcontrib
388   my @tfarr;
389   my @rfarr;
390   my @tbarr;
391   my @rbarr;
392   my $cmd;
393 < my $rtcmd = "rtcontrib $rtargs -h -ff -fo -n $nproc -c $nsamp " .
393 > my $rtcmd = "rcontrib $rtargs -h -ff -fo -n $nproc -c $nsamp " .
394          "-e '$kcal' -b kbin -bn $ndiv " .
395          "-o '$td/%s.flt' -m $fmodnm -m $bmodnm $octree";
396   my $rccmd = "rcalc -e '$tcal' " .
397          "-e 'mod(n,d):n-floor(n/d)*d' -e 'Kbin=mod(recno-.999,$ndiv)' " .
398 <        q{-if3 -e 'oval=(0.265*$1+0.670*$2+0.065*$3)/KprojOmega' } .
412 <        q[-o '${  oval  },'];
398 >        q{-if3 -e '$1=(0.265*$1+0.670*$2+0.065*$3)/KprojOmega' };
399   if ( $doforw ) {
400   $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
401          "-e 'xp=(\$3+rand(.12*recno+288))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
# Line 421 | Line 407 | $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
407   system "$cmd" || die "Failure running: $cmd\n";
408   @tfarr = `$rccmd $td/$fmodnm.flt`;
409   die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
410 + chomp(@tfarr);
411   @rfarr = `$rccmd $td/$bmodnm.flt`;
412   die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
413 + chomp(@rfarr);
414   }
415   if ( $doback ) {
416   $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
# Line 435 | Line 423 | $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
423   system "$cmd" || die "Failure running: $cmd\n";
424   @tbarr = `$rccmd $td/$bmodnm.flt`;
425   die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
426 + chomp(@tbarr);
427   @rbarr = `$rccmd $td/$fmodnm.flt`;
428   die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
429 + chomp(@rbarr);
430   }
431   # Output angle basis
432   print
# Line 445 | Line 435 | print
435                  <AngleBasis>
436                          <AngleBasisName>LBNL/Klems Full</AngleBasisName>
437                          <AngleBasisBlock>
438 <                                <Theta>0</Theta>
439 <                                <nPhis>1</nPhis>
440 <                                <ThetaBounds>
441 <                                        <LowerTheta>0</LowerTheta>
442 <                                        <UpperTheta>5</UpperTheta>
443 <                                </ThetaBounds>
454 <                                </AngleBasisBlock>
455 <                                <AngleBasisBlock>
456 <                                <Theta>10</Theta>
457 <                                <nPhis>8</nPhis>
458 <                                <ThetaBounds>
459 <                                        <LowerTheta>5</LowerTheta>
460 <                                        <UpperTheta>15</UpperTheta>
461 <                                </ThetaBounds>
462 <                                </AngleBasisBlock>
463 <                                <AngleBasisBlock>
464 <                                <Theta>20</Theta>
465 <                                <nPhis>16</nPhis>
466 <                                <ThetaBounds>
467 <                                        <LowerTheta>15</LowerTheta>
468 <                                        <UpperTheta>25</UpperTheta>
469 <                                </ThetaBounds>
470 <                                </AngleBasisBlock>
471 <                                <AngleBasisBlock>
472 <                                <Theta>30</Theta>
473 <                                <nPhis>20</nPhis>
474 <                                <ThetaBounds>
475 <                                        <LowerTheta>25</LowerTheta>
476 <                                        <UpperTheta>35</UpperTheta>
477 <                                </ThetaBounds>
478 <                                </AngleBasisBlock>
479 <                                <AngleBasisBlock>
480 <                                <Theta>40</Theta>
481 <                                <nPhis>24</nPhis>
482 <                                <ThetaBounds>
483 <                                        <LowerTheta>35</LowerTheta>
484 <                                        <UpperTheta>45</UpperTheta>
485 <                                </ThetaBounds>
486 <                                </AngleBasisBlock>
487 <                                <AngleBasisBlock>
488 <                                <Theta>50</Theta>
489 <                                <nPhis>24</nPhis>
490 <                                <ThetaBounds>
491 <                                        <LowerTheta>45</LowerTheta>
492 <                                        <UpperTheta>55</UpperTheta>
493 <                                </ThetaBounds>
494 <                                </AngleBasisBlock>
495 <                                <AngleBasisBlock>
496 <                                <Theta>60</Theta>
497 <                                <nPhis>24</nPhis>
498 <                                <ThetaBounds>
499 <                                        <LowerTheta>55</LowerTheta>
500 <                                        <UpperTheta>65</UpperTheta>
501 <                                </ThetaBounds>
502 <                                </AngleBasisBlock>
503 <                                <AngleBasisBlock>
504 <                                <Theta>70</Theta>
505 <                                <nPhis>16</nPhis>
506 <                                <ThetaBounds>
507 <                                        <LowerTheta>65</LowerTheta>
508 <                                        <UpperTheta>75</UpperTheta>
509 <                                </ThetaBounds>
510 <                                </AngleBasisBlock>
511 <                                <AngleBasisBlock>
512 <                                <Theta>82.5</Theta>
513 <                                <nPhis>12</nPhis>
514 <                                <ThetaBounds>
515 <                                        <LowerTheta>75</LowerTheta>
516 <                                        <UpperTheta>90</UpperTheta>
517 <                                </ThetaBounds>
438 >                        <Theta>0</Theta>
439 >                        <nPhis>1</nPhis>
440 >                        <ThetaBounds>
441 >                                <LowerTheta>0</LowerTheta>
442 >                                <UpperTheta>5</UpperTheta>
443 >                        </ThetaBounds>
444                          </AngleBasisBlock>
445 +                        <AngleBasisBlock>
446 +                        <Theta>10</Theta>
447 +                        <nPhis>8</nPhis>
448 +                        <ThetaBounds>
449 +                                <LowerTheta>5</LowerTheta>
450 +                                <UpperTheta>15</UpperTheta>
451 +                        </ThetaBounds>
452 +                        </AngleBasisBlock>
453 +                        <AngleBasisBlock>
454 +                        <Theta>20</Theta>
455 +                        <nPhis>16</nPhis>
456 +                        <ThetaBounds>
457 +                                <LowerTheta>15</LowerTheta>
458 +                                <UpperTheta>25</UpperTheta>
459 +                        </ThetaBounds>
460 +                        </AngleBasisBlock>
461 +                        <AngleBasisBlock>
462 +                        <Theta>30</Theta>
463 +                        <nPhis>20</nPhis>
464 +                        <ThetaBounds>
465 +                                <LowerTheta>25</LowerTheta>
466 +                                <UpperTheta>35</UpperTheta>
467 +                        </ThetaBounds>
468 +                        </AngleBasisBlock>
469 +                        <AngleBasisBlock>
470 +                        <Theta>40</Theta>
471 +                        <nPhis>24</nPhis>
472 +                        <ThetaBounds>
473 +                                <LowerTheta>35</LowerTheta>
474 +                                <UpperTheta>45</UpperTheta>
475 +                        </ThetaBounds>
476 +                        </AngleBasisBlock>
477 +                        <AngleBasisBlock>
478 +                        <Theta>50</Theta>
479 +                        <nPhis>24</nPhis>
480 +                        <ThetaBounds>
481 +                                <LowerTheta>45</LowerTheta>
482 +                                <UpperTheta>55</UpperTheta>
483 +                        </ThetaBounds>
484 +                        </AngleBasisBlock>
485 +                        <AngleBasisBlock>
486 +                        <Theta>60</Theta>
487 +                        <nPhis>24</nPhis>
488 +                        <ThetaBounds>
489 +                                <LowerTheta>55</LowerTheta>
490 +                                <UpperTheta>65</UpperTheta>
491 +                        </ThetaBounds>
492 +                        </AngleBasisBlock>
493 +                        <AngleBasisBlock>
494 +                        <Theta>70</Theta>
495 +                        <nPhis>16</nPhis>
496 +                        <ThetaBounds>
497 +                                <LowerTheta>65</LowerTheta>
498 +                                <UpperTheta>75</UpperTheta>
499 +                        </ThetaBounds>
500 +                        </AngleBasisBlock>
501 +                        <AngleBasisBlock>
502 +                        <Theta>82.5</Theta>
503 +                        <nPhis>12</nPhis>
504 +                        <ThetaBounds>
505 +                                <LowerTheta>75</LowerTheta>
506 +                                <UpperTheta>90</UpperTheta>
507 +                        </ThetaBounds>
508 +                        </AngleBasisBlock>
509                  </AngleBasis>
510          </DataDefinition>
511   ';
# Line 536 | Line 526 | print
526   # Output front transmission (transposed order)
527   for (my $od = 0; $od < $ndiv; $od++) {
528          for (my $id = 0; $id < $ndiv; $id++) {
529 <                print $tfarr[$ndiv*$id + $od];
529 >                print $tfarr[$ndiv*$id + $od], ",\n";
530          }
531          print "\n";
532   }
# Line 553 | Line 543 | print
543                          <WavelengthDataDirection>Reflection Front</WavelengthDataDirection>
544                          <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
545                          <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
546 <                        <ScatteringDataType>BRDF</ScatteringDataType>
546 >                        <ScatteringDataType>BTDF</ScatteringDataType>
547                          <ScatteringData>
548   ';
549   # Output front reflection (transposed order)
550   for (my $od = 0; $od < $ndiv; $od++) {
551          for (my $id = 0; $id < $ndiv; $id++) {
552 <                print $rfarr[$ndiv*$id + $od];
552 >                print $rfarr[$ndiv*$id + $od], ",\n";
553          }
554          print "\n";
555   }
# Line 586 | Line 576 | print
576   # Output back transmission (transposed order)
577   for (my $od = 0; $od < $ndiv; $od++) {
578          for (my $id = 0; $id < $ndiv; $id++) {
579 <                print $tbarr[$ndiv*$id + $od];
579 >                print $tbarr[$ndiv*$id + $od], ",\n";
580          }
581          print "\n";
582   }
# Line 603 | Line 593 | print
593                          <WavelengthDataDirection>Reflection Back</WavelengthDataDirection>
594                          <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
595                          <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
596 <                        <ScatteringDataType>BRDF</ScatteringDataType>
596 >                        <ScatteringDataType>BTDF</ScatteringDataType>
597                          <ScatteringData>
598   ';
599   # Output back reflection (transposed order)
600   for (my $od = 0; $od < $ndiv; $od++) {
601          for (my $id = 0; $id < $ndiv; $id++) {
602 <                print $rbarr[$ndiv*$id + $od];
602 >                print $rbarr[$ndiv*$id + $od], ",\n";
603          }
604          print "\n";
605   }

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines